<template>
<div>
 <a-breadcrumb style="margin-left:10px;margin-top:5px;font-weight:bold;">

    <a-breadcrumb-item  @click="toPage()">
      <home-outlined />
      <span>任务分配</span>
    </a-breadcrumb-item>
    <a-breadcrumb-item @click="toPage2()">任务【{{taskName}}】</a-breadcrumb-item>
    <a-breadcrumb-item >分配填报人</a-breadcrumb-item>
  </a-breadcrumb>
  </div>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 批量分配</a-button>
          
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <RateTaskuserModal @register="registerModal" @success="handleSuccess"></RateTaskuserModal>
  </div>
</template>

<script lang="ts" name="rate-rateTaskuser" setup>
   import {onMounted, ref, computed, unref,toRaw,inject} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import RateTaskuserModal from './components/RateTaskuserModal.vue'
  import {columns, searchFormSchema} from './RateTaskuser.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl,getOneTask} from './RateTaskuser.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { useRoute } from 'vue-router';
  import { useRouter } from 'vue-router';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useUserStore } from '/@/store/modules/user';
  import { HomeOutlined, UserOutlined } from '@ant-design/icons-vue';
  import { useTabs } from '/@/hooks/web/useTabs';
  const { closeCurrent, refreshPage, setTitle } = useTabs();
  const userStore = useUserStore();
  const route = useRoute();
  const router = useRouter();
  const taskName = ref('');
  
  let ratedeptid = ref('');
  const rateTaskId = ref('');
   const key = ref(1)
  
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '任务分配',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 120,
               fixed:'right'
            },
             beforeFetch(params) {
              params.rateTaskId=rateTaskId.value
              params = Object.assign(params)
            },
      },
       exportConfig: {
            name:"任务分配",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext
  onMounted(() => {
    ratedeptid = toRaw(route.query).id;
    
    rateTaskId.value = toRaw(route.query).rateTaskId;
    //console.log('user-------------rateTaskId: ', rateTaskId);
    
    getOneTask({id:rateTaskId.value}).then(rep=>{
    
    //console.log('user-------------getOneTask: ', rep);
    taskName.value = rep.taskName;
  })

  if(!!rateTaskId){
    setProps({searchInfo:{rateTaskId:rateTaskId.value}});
    // reload()
      }
    })

   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
       key,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      //(selectedRowKeys.value = []) && reload();
      key.value++;
      reload();
      //why mod 
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [ 
     
         {
           label: '重新分配填报人',
           onClick: handleEdit.bind(null, record),
         } 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [ 
        
        
         /**
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         }
         */
       ]
   }

function toPage() {
    closeCurrent();
    router.push({path: '/rate/rateTaskList'})
    
   
   }

function toPage2() {
    closeCurrent();
    router.push({path: '/rate/rateTaskdeptList',query:{id:rateTaskId.value}})
    
   
   }

</script>

<style scoped>

</style>